\chapter{Implementation}\label{ch:implementation}
This chapter describes the software architecture behind the coupling simulation, the essential components, their challenges, and how they were overcome. Said components can roughly be categorized as follows:
\begin{compactdesc}
    \item[(External) Setup Tools:] These are programs used to set up a simulation (-sequence), the errors, and the interactions to be verified before starting a training.
    \item[Interactibles:] Tools like screwdrivers, measuring devices, buttons, but also the entire coupling model and its components, how they interact with each other and how the user can operate them.
    \item[Simulation Logic:] These components tie the parts of the aforementioned categories together such that the entire simulation is realistic and logically coherent, the user gets guided through the procedure, and the operations are tracked and recorded in some form.
\end{compactdesc}
\begin{figure}[htb]
    \centering
    \includegraphics[width=.8\textwidth]{img/30_implementation/misc/ProgrammOverview.png}
    \caption{Programm Overview}
    \label{fig:programmOverview}
\end{figure}

\Cref{fig:programmOverview} provides a general overview of the components of the entire simulation. The arrows indicate the direction of the information.

As it becomes apparent, the Tree Controller is essential to the entire program. This component is aware of the current step within the decision tree (i.e., the instruction manual), knows which modifications to the model must be made, and what else must be done in the simulation before continuing to the next step. It receives its data from the externally prepared instruction tree. The representation thereof is more closely discussed in \cref{sec:impltreecreat}. 

As one of the main tasks of this thesis is to compare the Meta (Oculus) hand-tracking system with the SenseGloves as means to interact in the 3D world, the app has to support both input systems in every component. Most of this is solved via a dedicated interface explained among others in \cref{sec:snappableobj}.

The scenario controller affects the model based on the current step in the tree controller. As such, it edits parts of the coupling model, the display of the multimeter, etc. These Scenarios can be created by an expert through the Scenario editor, allowing them to select which errors to simulate.

The step controller, together with the assembly, ensures a correct (dis-) assembly of the coupling model and provides fine-grained instructions on what to do at the current point in time.

All of the components mentioned above are further elaborated in this section.

\paragraph{Note} all components can talk to the report generator, and some of them can also relay information to the information controller. Both provide a logger-like functionality to track what the user has done. For clarity, the report generator is not depicted in \cref{fig:programmOverview}.



\section{Tree Representation} \label{sec:impltreecreat}
As explained in \cref{ssec:treeRep}, the current representation is not optimal for various reasons, hence the move towards a new format. The JSON format was selected as a base due to its simplicity, support across most programming languages, and human readability. Furthermore, most data objects (e.g., \texttt{dataclasses} in Python \cite{PythonDataclass}, \texttt{Records} in \csharp\cite{CSharpRecords}) provide out-of-the-box serializer and deserializer for that format. This format can also be validated automatically as outlined in the \cref{p:treevalidate}. Since JSON is a key-value storage format, it can easily be extended later by adding new keys, for example, meta information like the start node, used API version, etc. 

\Cref{lst:treerepresentation} depicts an excerpt of the current updated format. As it becomes apparent, this format accommodates all data within one file and logically subordinates everything to the respective node in a logical way, e.g., \texttt{ar\_features} is a child of the actual node. 

\begin{lstlisting}[language=json, caption={Excerpt from the Tree Representation}, label=lst:treerepresentation, breaklines=true]
{
  "nodes": {
    "NKKD": {
      "description": "Start",
      "long_description": "Starte...",
      "images_dir": "18_RiegelKupplung",
      "ar_features": [
        {
          "cad_part": "660-451-ALT_II",
          "indicators": [
            {
              "position": {
                "x": 0.38,
                "y": 0.56
              }
            }
          ]
        }
      ]
    },
    ...
  },
  "edges": {
    "VYGF": {
      "source": "NKKD",
      "target": "VHDT",
      "type": "option",
      "description": "1. Teil",
      "long_description": "Weiter zu 1. Teil"
    },
    ...
  },
  "start_node": "NKKD"
}
\end{lstlisting}


\subsection{Automatic Format Converter} \label{p:tree_converter}
Since this is only a change of representation, the conversion from the old to the new format can easily be automated. The tree utilities \cite{luziMAUtils} provides one such implementation written in Python that proved to be very useful for reusing the trees from previous work \cite{AntoniaMT,SilasMT, IanHutterST} in this thesis. 

\subsection{Example Usage in \csharp}
Several JSON (de-)serializing libraries exist for \csharp{}. This section provides an example using the implementation from Newtonsoft \cite{newtonsoftjson} in conjunction with \csharp{}-Records. The first step is to recreate the tree data structure using Records (see \cref{lst:treereprecords}). Using Records, in that case, is favorable over the simple key-value storage (i.e., dictionaries) as records can leverage \csharp{}'s type-checker to prevent most mistakes already during compile time when accessing the data at a later point in time. 

\begin{lstlisting}[language={[Sharp]C}, caption={Tree Representation using records}, label=lst:treereprecords, breaklines=true]
public record Edge(string source, string target, string type, string description, string long_description);
public record Position(float x, float y);
public record Indicatior(Position position, string type);
public record ArFeature(string cad_part, Indicatior[] indicators);
public record Node(string description, string long_description, string images_dir, ArFeature[] ar_features, string[] assembly_steps);
public record Tree(Dictionary<string, Node> nodes, Dictionary<string, Edge> edges, string start_node);
\end{lstlisting}

Reading the file into the \texttt{Tree}-Record is as simple as displayed in \cref{lst:treedeserialize}. There, \texttt{JsonConvert} is provided by \texttt{Newtonsoft.Json}. The \texttt{DeserializeObject} also throws an exception should the supplied file deviate from the predefined Record in an unrecoverable manner.

\begin{lstlisting}[language={[Sharp]C}, caption={Deserializing the tree}, label=lst:treedeserialize, breaklines=true]
using Newtonsoft.Json;
...
tree = JsonConvert.DeserializeObject<Tree>("<json_path>");
\end{lstlisting}

\subsection{Tree Utils} \label{ssec:treeutils}
The Tree Utils is a small class that uses the logic mentioned above to read in a tree representation. Furthermore, it provides some helper functions to facilitate the interaction with the tree, e.g., a function that lists all edges leaving a particular node. It also contains some logic to keep track of one node and follow its edge by edge.  


\subsection{Tree Validation} \label{p:treevalidate}
In the approach mentioned above, JSON is not only used as a simple key-value storage. Moreover, it is the output format of the (tree-) object serialization. Various validation standards have been developed for that very purpose, allowing a program to validate the JSON before deserializing. One of the most widespread, programming language-agnostic standard is the so-called JSON-Schema \cite{json_schema}. The programmer previously defines the expected content of the data in a different, standardized JSON format, the \textit{Schema}. Then, the supplied data can be validated using one of the various implementations of the JSON-Schema-Validator - \cite{newtonsoftjsonschema} in this case. The complete Schema for the format mentioned earlier can be found in \cref{lst:jsocnschema}.


\subsection{Future of \treecreator{}}
The usage of the "old" \treecreator{} proved to be cumbersome. The most wished-for feature was to be able to edit the tree using the mouse. That is why the \textit{Content Creation Tool} \cite{treeToolJulian} was built using a similar underlying representation (mostly) compatible with the one suggested here. 


\section{Tree Controller}\label{sec:treecontroller}
As previously mentioned, the tree controller is the most integral part of the coupling simulation. Its main task is to read the tree, display the current instruction, manage the navigation through the manual, and last but not least, dispatch the required steps to the assembly and interaction controller. The instruction display and the navigation through the manual are depicted in \cref{fig:treecontroller}. If requested, the tree controller ensures that associated interaction and assembly steps (see \cref{sec:interactioncontroller,ssec:stepcollection}) have been completed before allowing the user to continue to the next instruction. 

\begin{figure}[htb]
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/ManualOutput.png}
         % \caption{Defining the tip's connection-point}
         % \label{sfig:def_tip_cp}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/NavigationButtons.png}
         % \caption{Defining the tip's endpoint}
         % \label{sfig:def_tip_ep}
     \end{subfigure}
     \caption{The manual and the navigation buttons}
     \label{fig:treecontroller}
\end{figure}

The tree utils (\cref{ssec:treeutils}) keep track of the current step within the manual. The instructions of said (step-)node are displayed on the panel, and the required assembly and interaction steps are delegated to the respective controllers. Then, the tree controller retrieves a list of all edges connected to that node and creates a button with a callback function attached to it. This function deletes the existing buttons, follows the respective edge using the tree utils, retrieves the instructions, and creates new navigation buttons. Additionally, before moving, this callback function can check whether all interaction- and assembly steps have been completed and communicate this to the user via the information controller (see \cref{sec:inforContr}).


\section{Snappable Objects}\label{sec:snappableobj}
Installing objects on another object and removing them again is the single most crucial interaction within the coupling model. This interaction covers installing screws, measurement devices, tools, covers, other components of the model, and so on.

\begin{figure}[htb]
    \centering
     \includegraphics[width=.8\textwidth]{img/30_implementation/snappables/ghost_sphere.png}
     \caption{Preview of where the object can be snapped towards - the sphere indicates the tolerance}
    \label{fig:ghost_sphere}
\end{figure}

First and foremost, a snappable object can be snapped to a predetermined position using some command, e.g., if the object has been grabbed and is released close enough to said position, it will be snapped into that position. In that case, said snapping end position needs to be visualized in some form (see \cref{fig:ghost_sphere}). Determining the snappable position should be as easy as defining an endpoint and a connection point (see \cref{sfig:def_tip_cp,sfig:def_tip_ep}) which are both independent of the object's origin. This logic will also prove helpful in creating screws (see \cref{sec:screwable}). Furthermore, some objects have multiple snapping points, e.g., the measuring tip of a multimeter can snap to several measuring points.


\begin{figure}[htb]
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/snappables/tip_connection_point.png}
         \caption{Defining the tip's connection-point}
         \label{sfig:def_tip_cp}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/snappables/tip_define_endpoint.png}
         \caption{Defining the tip's endpoint}
         \label{sfig:def_tip_ep}
     \end{subfigure}
     \caption{Defining of the relevant point of the snappable object}
     \label{fig:defingin_tip_cpep}
\end{figure}


Dealing with two different input systems, neither of which supports all features mentioned above, requires a custom implementation for snappable objects. This implementation directly interacts with the respective input systems (see \cref{sec:oculus_sdk,sec:sg_sdk}). \Cref{fig:InterfacingSnappables} shows why such an interface is essential. Otherwise, all these connections must be coded for every input system. 

\begin{figure}[htb]
    \centering
     \includegraphics[width=.8\textwidth]{img/30_implementation/snappables/InterfacingSnappables.png}
     \caption{A common interface for easy integration with various components}
    \label{fig:InterfacingSnappables}
\end{figure}


\subsection{\texttt{ISnappable} Interface}\label{ssec:isnappable}
The \texttt{ISnappable} Interface takes the connection point, the endpoint (both Unity Transforms), and a \texttt{GameObject}. \textit{The following explanation assumes that the connection-point is a child of the \texttt{GameObject}}. This child-parent relation means that by moving the \texttt{GameObject}, the connection point moves alongside. The general idea behind the \texttt{ISnappable} is - when requested through a function - transform \texttt{GameObject}'s transformation in such a way that the connection- aligns with the endpoint. This transform is only performed if the original distance between the connection- and endpoint is below a predefined tolerance. 

Let us illustrate that problem in a simple 2D case. In \cref{fig:snap-propbem} \textbf{A} denotes the endpoint's \textbf{B} the connection point's and \textbf{C} the \texttt{GameObject}'s transformation. Without restriction of generality, the z-Axis of \textbf{C} and \textbf{B} are aligned. The task is to find the transform \textbf{C'} (visible in \cref{fig:snapsolution2d}), which aligns \textbf{B} with \textbf{A}. Intuitively this looks as follows:

\begin{compactenum}
    \item Move \textbf{C} in such a way that \textbf{B} falls onto the origin
    \item Rotate \textbf{C} around the origin by $\vec \alpha$
    \item Transform \textbf{C} such that \textbf{B} falls back on its original place
    \item Move \textbf{C} by $\vec d$, as such the \textbf{B} fall s onto \textbf{A}
\end{compactenum}

Expressed using Affine Transformations \cite{wiki:Affine_transformation} and Augmented Matrices \cite{wiki:Augmented_matrix} the solution is described in \cref{eq:snapp}. $T_{OA}$ denotes the Transformation matrix from the origin to \textbf{A}, $T_{OB}$ to \textbf{B} and $T_{OC}$ to \textbf{C} respectively.

\begin{equation}\label{eq:snapp}
    T_{OC'} = T_{OC}\cdot {T_{OB}}^{-1} \cdot T_{OA}
\end{equation}


\begin{figure}[htb]
     \begin{subfigure}[htb]{0.59\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/snappables/SnappableProblem.png}
         \caption{Problem: A and B not aligned}
         % \label{sfig:def_tip_cp}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.39\textwidth}
         \centering
         \includegraphics[width=.9\textwidth]{img/30_implementation/snappables/SnappableAim.png}
         \caption{Aim: B snapped onto A}
         % \label{sfig:def_tip_ep}
     \end{subfigure}
     \caption{Snapping an Object onto its endpoint}
     \label{fig:snap-propbem}
\end{figure}

\begin{figure}[htb]
    \centering
     \includegraphics[width=.7\textwidth]{img/30_implementation/snappables/SnappableSolution.png}
     \caption{Retrieving the transform for C to snap B onto A }
    \label{fig:snapsolution2d}
\end{figure}

Furthermore, the \texttt{ISnappable} Interface provides a UnityEvent \cite{UnityUnityEvent} that is invoked when the object is snapped.



\subsection{\texttt{IGrabbableSnappable} Interface}
The \texttt{IGrabbableSnappable} Interface builds upon \texttt{ISnappable} and extends it by the "ghost" display logic (see \cref{fig:ghost_sphere}). The ghost and the surrounding sphere only display if the corresponding object is grabbed hence the name \texttt{IGrabbableSnappable}. Once the grabbable object is released, the display of the ghost is disabled again. This logic has intentionally been laid off into an additional interface, as the snappable logic might be of use in other cases which do not need to display a ghost.

To use that interface, it provides the \texttt{Grab} and \texttt{Release} functions. The \texttt{Grab} function is intended to be called when grabbing that very object and triggers the ghost display. The \texttt{Release} function should be called when the object is released. When no other hands interact with the object, the ghost display is disabled. Additionally, when released, the \texttt{ISnappable} interface checks whether "a snap" should be performed and does so if needed.


As the Ghost display is essentially a differently colored duplicate of the original object, the display logic leverages the logic from \cref{ssec:isnappable} by defining the endpoint of the ghost as an offset of the original object's endpoint by a predetermined distance - in that case - in the negative z direction of the endpoint. Defining the offset along any axis simplifies the mathematics discussed in \cref{sec:screwable}. 

Furthermore, the \texttt{IGrabbableSnappable} Interface provides a \texttt{UnityEvent} \cite{UnityUnityEvent} which is invoked whenever an object is grabbed and one which is invoked when the object is released. 

\subsection{\texttt{BaseSnappable}}
The \texttt{BaseSnappable} virtual class sets up most of the logic needed for a snappable object and implements the \texttt{IGrabbableSnappable} Interface. Additionally, it provides some logic to create all \texttt{GameObjects} which are part of the ghost display. It is done only the first time the ghost display is requested. Using the \texttt{SerializeField} annotation \cite{UnitySerializeField}, the connection-point, the ghost-color as well as the \texttt{UnityEvent}s can be supplied via drag and drop of the UnityEditor. It is intended to be attached to a \texttt{GameObject} which can be grabbed using any input system.

\subsubsection{Variants}
This section presents some applications of the \texttt{BaseSnappable} base-class.

\paragraph{\texttt{SimpleSnappable}} \label{par:simplesnappable}
The \texttt{SimpleSnappable} implements the abstract class \texttt{BaseSnappable} by adding the single endpoint. This class is intended, e.g., to snap the cover to the electronic box, and snap cables back to their initial pose. \Cref{fig:simpleSnappableEditor} shows how such a component can be configured. 

\begin{figure}[htb]
    \centering
    \includegraphics[width=.6\textwidth]{img/30_implementation/snappables/SimpleSnappableUnityEditor.png}
    \caption{Editing the simple snappable component}
    \label{fig:simpleSnappableEditor}
\end{figure}


\paragraph{\texttt{SwapParentSimpleSnappable}} This class builds upon the \texttt{SimpleSnappable} class. When snapping to a \texttt{GameObjects} which in and of itself is grabbable, the \texttt{GameObjects}'s parent needs to be swapped to the snappable object. This behavior is, e.g., needed for the replacement gasket of the cylinder connector.

\paragraph{\texttt{MultiSnappable}}
The \texttt{MultiSnappable} implements the abstract class \texttt{BaseSnappable} by adding multiple endpoints. This component can be used, e.g., to snap the multimeter to various measuring points. 


\subsection{Using \texttt{BaseSnappable} with Meta SDK}\label{ssec:snapwithMetaSDK}
The Meta SDK provides a so-called \texttt{UnityEventWrapper} which allows to directly call the \texttt{Grab} function of the \texttt{IGrabbableSnappable} interface when grabbed and the \texttt{Release} function when released.  

\subsection{Using \texttt{BaseSnappable} with \texttt{SG\_Grabable}}\label{ssec:sg_grabableoverwork}
Contrary to the Meta SDK, the SenseGlove SDK does not provide any UnityEvents to call a function when an object has been grabbed. As these functions need to be called, a wrapper required around the \texttt{SG\_Grabable} class inheriting the original class was required, adding UnityEvents for the grab and release callback, and overriding the \texttt{StartGrab} and the \texttt{StartRelease} function to call the respective events beforehand.

\section{Screws / Screwing Motion} \label{sec:screwable}
The screw's logic build up on the snappable logic from \cref{sec:snappableobj}. The interaction is extended by forcing the user to remove (or install) the screw using an appropriate screwdriver (see \cref{par:tool_selection}).   

\subsection{The Screwing Motion}A screw consists of a helical ridge which provides the typical screwing motion \cite{wiki:Screw}. The so-called pitch of this ridge decides how far the screw moves along the screwing axis. Given a pitch $p$, the normalized screwing axis $\vec n$ and a rotation angle $\alpha$  (in degrees), the screwing motion can be calculated as in \cref{eq:screwingmotion}.
\begin{equation}\label{eq:screwingmotion}
    \vec x_{new} = \frac{\alpha}{360\deg} \cdot p \cdot \vec n 
\end{equation}

\subsection{Screw Objects}
This section explains the implementation of the entire logic behind the screw, the screwing motion, and the restriction thereof once placed into the screw hole and tightened.

\subsubsection{\texttt{IScrewable} Interface}
The \texttt{IScrewable} Interface extends the \texttt{ISnappable} Interface by additionally providing a \texttt{Rotate} function that takes the angle as an argument. Furthermore, this interface requires the \texttt{Pitch}, a \texttt{RequiredTool} (see \ref{ssec:Screwdriver}), and the count of so-called \texttt{SnapPoints} needed in \cref{ssec:Screwdriver} to determine whether this screw is Hex, Phillips, or Slotted. Using \cref{eq:screwingmotion}, the \texttt{Rotate} function calculates the \texttt{GameObject}'s new position. The interface uses the z-Axis (the blue arrow) of the \texttt{ISnappable} Interface as the screwing axis (see \cref{ssec:isnappable}). Once the screw is turned close enough to the endpoint, \texttt{IScrewable} leverages the logic from \cref{ssec:isnappable} to move the screw to its end position.


\subsubsection{Integrating with \texttt{BaseSnappable}}
The class \texttt{SimpleScrew} extends \texttt{SimpleSnappable} (see \cref{par:simplesnappable}) and implements the \texttt{IScrewable} Interface by allowing the properties mentioned above to be selected using the Unity Editor (see \cref{fig:screweditor}). Additionally, the component requires the screw length to be set to offset the snapping endpoint in front of the screw-hole by said length. 

\begin{figure}[htb]
    \centering
    \includegraphics[width=.6\textwidth]{img/30_implementation/snappables/ScrewUnityEditor.png}
    \caption{Editing the screw component}
    \label{fig:screweditor}
\end{figure}

\subsection{Screwdriver, Wrenches, and Allen keys} \label{ssec:Screwdriver}
To tighten or loosen a screw using a screwdriver, the app must determine how much to rotate the screw. The rotation is determined using colliders and another axis illustrated in \cref{fig:ScrewdriverColliderandstuff}. Upon intersecting with the screw's collider, the \texttt{Screwdriver} measures its rotation around the z-axis. If the \texttt{Screwdriver}'s tool type (see \cref{fig:screwdrivereditor}) matches the screw's \texttt{RequiredTool} (see \cref{fig:screweditor}), the \texttt{Rotate} function of the screw is called with the measured rotation as an argument. 

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.59\textwidth}
         \centering
         \includegraphics[width=\textwidth,trim={0 70 0 70},clip]{img/30_implementation/snappables/ScrewdriverCollider.png}
         % \caption{The initial and reassembled state}
         % \label{sfig:worldCtr}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.375\textwidth}
         \centering
         \includegraphics[width=\textwidth,trim={0 50 0 30},clip]{img/30_implementation/snappables/ScrewdriverConnector.png}
         % \caption{The installed plug}
         % \label{sfig:handsCtr}
     \end{subfigure}
     \caption{Collider and screwdriver axis}
     \label{fig:ScrewdriverColliderandstuff}
\end{figure}


\begin{figure}[htb]
    \centering
    \includegraphics[width=.6\textwidth]{img/30_implementation/snappables/ScrewdriverUnityEditorset.png}
    \caption{Editing the screwdriver component}
    \label{fig:screwdrivereditor}
\end{figure}


The above-suggested approach in and of itself proved to be rather tedious to use, as it was hard to keep the screw and the Screwdriver aligned while working in VR. That led to the decision to restrict the movement of the Screwdriver such that it can only be rotated, moved around, and along the screwing axis as illustrated in \cref{fig:ScrewdriverRestricted}. This behavior can easily be achieved by letting \texttt{Screwdriver} be a MultiSnappable Object (see \cref{sec:snappableobj}). Once the object is snapped, the movement is restricted within some distance around the screw.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.55\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/snappables/ScrewdriverMoveRestriced.png}
         \caption{Restrict the movement}
         % \label{sfig:worldCtr}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.39\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/snappables/ScrewdriverRotateRestriced.png}
         \caption{Restrict rotation}
         \label{sfig:screwdriverrestricrotation}
     \end{subfigure}
     \caption{Restricted movement of the screw}
     \label{fig:ScrewdriverRestricted}
\end{figure}

\subsubsection{Screw Types}
As previously mentioned, there exists a variety of screw types, e.g., Slotted, Phillips, Hex (inside and outside), and Torx. The only difference is "how often" the screw and the tool can interlock per rotation, e.g., the Slotted screwdriver can interlock twice per rotation. Assuming that the blue arrows align in \cref{fig:screwdriverinterlock}, which is guaranteed by the suggested approach restricting the movement along that very axis once snapped, the angular difference between both red arrows can be calculated. With that information, the algorithm can determine whether the tool and screw interlock as follows:
\begin{compactenum}
    \item Calculate the angle between the arrows
    \item Calculate the remainder when dividing that angle by $\frac{360}{n}$. Where $n$ denotes the number of interlocks per rotation. (careful   with "floating point remainders")
    \item If that remainder is smaller than some tolerance, the tool and screw interlock.
\end{compactenum}

\begin{figure}[htb]
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/ScrewHead.png}
         \caption{The screw connection-point}
         % \label{sfig:def_tip_cp}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/ScrewdriverHead.png}
         \caption{The screwdriver head with the connection point}
         % \label{sfig:def_tip_ep}
     \end{subfigure}
     \caption{Screw and screwdriver interlock}
     \label{fig:screwdriverinterlock}
\end{figure}

\subsubsection{Screwing Tool Types}\label{par:tool_selection}
This implementation is not limited to screwdrivers. It works with a wide variety of "screwing" tools. E.g., Allen keys and wrenches. The respective tool type can be selected via a dropdown and is associated with both the tool and the screw. That tye is then checked when interacting with the screw. This selection is displayed in \cref{fig:screwtypeselectionm}.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.8\textwidth]{img/30_implementation/misc/Screwtypes.png}
    \caption{Selection of tool types}
    \label{fig:screwtypeselectionm}
\end{figure}

\subsubsection{The \texttt{ISnapToZAxis} Interface}
The movement of the grabbed object is determined differently depending on the input system. That required the \texttt{ISnapToZAxis} Interface. Said interface takes a configuration consisting of the axis and a stop-point (the screws head) and intends to restrict the movement based on the supplied configuration.

\subsubsection{Creating \texttt{MovementProvider}}\label{sssec:MovProv}
The Screwdriver-\texttt{MovementProvider} is how the movement of the Oculus SDK can be restricted and implements \texttt{ISnapToZAxis}. Interestingly, there is no possibility of influencing the position of the movable object itself (see \cref{sfig:screwdriverrestricrotation}). Moreover, it only receives the new pose of the \textbf{hand}-interactable (i.e., the pose of the root of the hand, not the grabbed object). Thus one has to restrict the hands' movement such that it represents the correct trajectory. That is done in four steps: 
\begin{compactenum}
    \item Project the movement between the current and the new pose onto the axis
    \item Approximate the object's rotation based on current and new interactible's pose
    \item "Project" rotation onto the axis
    \item Determine new rotation \textbf{and position} of the hand interactible.  
\end{compactenum}
\paragraph{Note:} Contrary to \cref{sfig:screwdriverrestricrotation}, the interactable's origin can be much further away from the object. That penalizes the approximation and re-determination of the interactable pose because the calculation of step 4 moves the object again. For better precision, the exact new pose would greatly profit from an iterative approach until the error is below a threshold. Alternatively, even better,  an inverse kinematic solution, which would be a large project in and of itself.

\subsubsection{Extending \texttt{SG\_Grabable}}\label{ssec:extendingsggrabable}
Different from the movement provider, for the SenseGloves, the \texttt{SG\_Grabable} has to be modified in such a way that it implements the \texttt{ISnapToZAxis} Interface. This is done similarly to \cref{ssec:sg_grabableoverwork}, inheriting from the original \texttt{SG\_Grabable} and overriding the \texttt{CalculateTargetLocation} function. This function receives the proposed \textbf{object's pose}, takes said pose as well as the current pose, and proceeds as follows: 
\begin{compactenum}
    \item Project the movement onto the axis
    \item "Project" rotation onto the axis
\end{compactenum}

\paragraph{Note:} Other than the \texttt{MovementProvider}, the \texttt{SG\_Grabable} edits the object's pose directly, and the hand model's pose is afterward calculated based on the object's pose by the SG-backend. As such, the hand's pose is exact, and the movement generally feels more natural.

\section{Assembly Rules}\label{sec:assembly_rules}

Most interactions with the coupling model involve installing and removing objects. Including but not limited to removing a cover (remove the screws holding the cover), installing the plug of the diagnosis device (perform measurement), reassembling the coupling (i.e., remove the plug, install the cover and the screws), visible in \cref{fig:AssemblyStepsReasoning}. 

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/001_InitialCase.png}
         \caption{The initial and reassembled state}
         % \label{sfig:worldCtr}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/002_PlugInstalled.png}
         \caption{The installed plug}
         % \label{sfig:handsCtr}
     \end{subfigure}
     \caption{Coupling dis- and assembly interactions}
     \label{fig:AssemblyStepsReasoning}
\end{figure}

Unity Physics is neither performant nor precise enough to calculate the order in which one object has to be removed before another based on the MeshCollider \cite{UnityMeshCollider} of the involved objects. Thus, another solution is required: Analyzing the above problem makes it apparent that these single steps depend on each other and can easily be modeled using a dependency tree. For the above example, this tree could look as follows (see \cref{fig:deptree_example}). 

\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/tree_graphs/Tree-Base.png}
    \caption{Dependency tree for example in \cref{fig:AssemblyStepsReasoning}}
    \label{fig:deptree_example}
\end{figure}

Each dependency is represented as a directed edge in the graph and has the following meanings, explained on a more straightforward graph visible of \cref{fig:simpleDepRule}. 
\begin{compactenum}
    \item Remove B before removing A
    \item Remove B before  installing A
    \item Install A before installing B
\end{compactenum}

The dashed line indicates that these rules must not be fulfilled for the entire assembly to be considered assembled. E.g., in \cref{fig:AssemblyStepsReasoning}, the plug needs to be removed before installing the cover and vice versa. That means the plug cannot be installed in the fully assembled model state. These edges directly map to rules on what can be performed on the assembly, hence the name \textbf{Assembly Rule}. 
 
\begin{figure}[htb]
    \centering
    \includegraphics[width=.2\textwidth]{img/30_implementation/tree_graphs/SimpleRuleExpl.png}
    \caption{Simple Dependency Rule}
    \label{fig:simpleDepRule}
\end{figure}

Representing these dependencies as such a tree allows the program to automatically generate plans or manuals by cleverly traversing such a tree. E.g., if the task is to remove the Plug, it can deduce that the cover needs to be removed beforehand, whereas the Screws 1, 2, 3, and 4 have to be removed in advance simply by analyzing the dependency tree. 

\subsection{Rules as Finite-state Machine}
The assembly rules and the model's current state affect the \textit{movability} and \textit{installability} of the respective object. E.g., the cover cannot be removed as long as at least one screw is installed. These effects can be broken down into a simple per-assembly-rule Finite-state Machine (FSM, \cite{wiki:FSM}). This FSM is depicted in \cref{fig:fsmtree}, consisting of four states, with the only possible transitions as indicated. These states directly map onto the model state by inspecting two measurements: 
\begin{compactdesc}
    \item[Subrules:] Whether all child rules are fulfilled - essentially, whether all children have been removed. E.g., all screws are removed when looking at the cover. 
    \item[Removed:] Whether the object itself - e.g. the cover - is removed.
\end{compactdesc}

\begin{definition}\label{def:FSM_Transitions}
The only transitions allowed within the Assembly FSM are indicated in \cref{fig:fsmtree}.
\end{definition}

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/tree_graphs/Tree-Rule_FSM.png}
    \caption{The FSM based on the assembly rules}
    \label{fig:fsmtree}
\end{figure}

\subsection{Effect on Grabbability and Snappability}\label{ssec:grabandsnappabilityMapping}
The states of the FSM directly map onto the v or - expressed in terms of \cref{sec:snappableobj} - the \textit{grabbability} and the \textit{snappability} according to \cref{fig:fsmtreemapping}.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.4\textwidth]{img/30_implementation/tree_graphs/Tree-FSM-Mapping.png}
    \caption{Mapping FSM to \textit{movability} and \textit{installability}}
    \label{fig:fsmtreemapping}
\end{figure}


\subsection{Examples for the States of the FSM}
The following section provides a small example of how every state of Assembly FSM manifests itself w.r.t to the cover depending on the installed screws and the model's state. 

\paragraph{Note:} Since the screws have no dependants within the dependency tree, their sub rules are always fulfilled. Thus they can only exist in the states \texttt{S1} or \texttt{S2}.

\subsubsection{FSM State \texttt{S1}}
\Cref{fig:FSMstateS1} shows an example of the \texttt{S1} state: All screws have been removed, and so has the cover. Exclusively in this state, a user is allowed to install the cover again, as visible from \cref{fig:fsmtreemapping}. Screws and cover can all be moved around freely.
\paragraph{Note:} The removed cover allows for the plug to be installed. Also it does not prevent the screws from being installed.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.55\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/012_FSM_S1.png}
         % \caption{The initial and reassembled state}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.44\textwidth}
         \centering
         \includegraphics[width=.9\textwidth]{img/30_implementation/tree_graphs/S1-Example.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Example for FSM state \texttt{S1}: Screws and Cover removed}
     \label{fig:FSMstateS1}
\end{figure}


\subsubsection{FSM State \texttt{S2}}
\Cref{fig:FSMstateS2} shows an example of the \texttt{S2} state. The cover is installed, contrary to the \texttt{S1} state. It cannot be installed again. However, it can be moved around freely. So are the screws, which can also be installed.
\paragraph{Note:} The installed cover prevents the plug from being installed as the plug is in the \texttt{S3} state, i.e., blocked by the cover.  

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.55\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/013_FSM_S2.png}
         % \caption{The initial and reassembled state}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.44\textwidth}
         \centering
         \includegraphics[width=.9\textwidth]{img/30_implementation/tree_graphs/S2-Example.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Example for FSM state \texttt{S2}: Screws removed, cover still attached}
     \label{fig:FSMstateS2}
\end{figure}


\subsubsection{FSM State \texttt{S3}}
\Cref{fig:FSMstateS3} shows an example of the \texttt{S3} state: The cover is removed. However, there is a screw installed which prevents the cover from being installed. As per \cref{def:FSM_Transitions} this state can only be achieved from a fully assembled model by removing all screws, then removing the cover and installing one screw again. 
\paragraph{Note:} The removed cover allows for the plug to be installed.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.55\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/014_FSM_S3.png}
         % \caption{The initial and reassembled state}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.44\textwidth}
         \centering
         \includegraphics[width=.9\textwidth]{img/30_implementation/tree_graphs/S3-Example.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Example for FSM state \texttt{S3}: Cover removed, one screw still installed}
     \label{fig:FSMstateS3}
\end{figure}


\subsubsection{FSM State \texttt{S4}}
\Cref{fig:FSMstateS4} shows an example of the \texttt{S4} state. Both the cover and one screw are installed. As such, the cover cannot be removed.
\paragraph{Note:} The installed cover prevents the plug from being installed as the plug is in the \texttt{S3} state.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{0.55\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/assembly_rules/015_FSM_S4.png}
         % \caption{The initial and reassembled state}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{0.44\textwidth}
         \centering
         \includegraphics[width=.9\textwidth]{img/30_implementation/tree_graphs/S4-Example.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Example for FSM state \texttt{S4}: Cover and screw installed}
     \label{fig:FSMstateS4}
\end{figure}

\subsection{Algorithms}\label{ssec:algortithmatree}
As such a dependency tree can grow huge, it is not feasible to explicitly declare every step as part of an instruction when creating a manual. E.g., if one task is to install the diagonal device, one does not want to define the removal of the screws and the cover explicitly in the assembly step. Especially if steps grow in complexity and an increasing amount of interactions depend on each other. Luckily, this information is already present, given the dependency tree. This information allows the program to generate most of the instructions automatically.

\subsubsection{Determining open Rules until}
\Cref{lst:GetOpenRulesChainUntil} shows the algorithm used to recursively determine which rules need to be fulfilled before the \texttt{End} object can be removed. The result is ordered in the correct way, e.g., the screws are indicated to be removed before the cover.  That algorithm, thus, essentially generates automatic manuals for installing any new object.  

\begin{lstlisting}[language={[Sharp]C}, caption={Retrieve a (ordered) list of rules to fulfull until an object can be removed}, label=lst:GetOpenRulesChainUntil, breaklines=true]
public List<Rule> OpenRulesUntil(IGrabbableSnappable End) {
  List<Rule> res = new();
  foreach (Rule rule in AssemblyRules) {
    if (rule.RemObj == End) {
      foreach (RemoveRule subRule in 
               rule.Rules.Where(r => !r.Fulfilled))
        res.AddRange(GetOpenRulesChainUntil(subRule.RemObj));
      res.Add(rule);
    }
  }
  return res;
}
\end{lstlisting}


\begin{minipage}{0.3\textwidth}
        \includegraphics[width=\linewidth]{img/30_implementation/misc/openrulechain.png}
\end{minipage}
\hspace{1cm}
\begin{minipage}{0.6\textwidth}
This figure shows an example dependency tree. The green boxes indicate already removed objects. Calling the \texttt{OpenRulesUntil} with the \texttt{A} object as an argument yields a result similar to \texttt{[H, D, F, B]}. As the tree is not aware of \textit{left} and \textit{right}, the result might also be \texttt{[H, F, D, B]}. However, the order from the bottom to the top of the tree stays.
\end{minipage}
\noindent

\subsubsection{Reassemble entire Model}
\Cref{lst:GetCurrentTodoRulesUntilAssembled} returns all rules which need to be reversed, i.e., the object that needs to be installed until the entire assembly can be considered fully assembled \textbf{that can be completed at that very point in time}. This function generates the manual to reassemble the model entirely from any possible state.

\begin{lstlisting}[language={[Sharp]C}, caption={List all rules which assemble the model that can currently be fulfilled}, label=lst:GetCurrentTodoRulesUntilAssembled, breaklines=true]
public List<Rule> GetCurrentRulesUntilAssembled(){
  var NotAssembled = NotAssembledRelevantRules;
  var Result = NotAssembled.ToList();
  int index = 0;
  while (index < Result.Count) {
    var CurrResRule = Result[index];
    if (CurrResRule.Rules.Any(
          r => NotAssembled.Any(
            nar => nar.ObjToRem == r.ObjToRem))) {
      Result.RemoveAt(index);
      continue;
    }
    index++;
  }
  return Result;
}
\end{lstlisting}
\begin{minipage}{0.3\textwidth}
        \includegraphics[width=\linewidth]{img/30_implementation/misc/asseembleCompletely.png}
\end{minipage}
\hspace{1cm}
\begin{minipage}{0.6\textwidth}
This figure shows an example dependency tree, the green boxes indicate already removed objects. Calling the \texttt{GetCurrentRulesUntilAssembled} returns all currently installable objects similar to \texttt{[D, F, G]}.    
\end{minipage}
\noindent


\subsection{Defining Rules through the \texttt{Assembly} Component}\label{ssec:assemblycomp}
Through the Unity Editor, one can easily define the assembly rules (see \cref{sec:assembly_rules}). The \texttt{Assembly} contains the collection of all rules as well as the algorithms (from \cref{ssec:algortithmatree}). Its task is to enforce the logic explained throughout this section. As such, it disables the grabbability and snappablilty of all objects known through the defined rules based on the logic explained in \cref{ssec:grabandsnappabilityMapping}. 

Defining rules is illustrated in \cref{fig:defineAssemRule}. One can drag and drop an \texttt{GameObject} that implements the \texttt{IGrabbableSnappable} interface in the object to remove the slot and can then create the rules by dragging the more \texttt{IGrabbableSnappable} objects into the "Rules to fulfill before the object can be moved"-List.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/misc/defineRulesThroughAssembly.png}
    \caption{Defining an assembly rule}
    \label{fig:defineAssemRule}
\end{figure}

\subsection{The Step Collection and the Step Controller}\label{ssec:stepcollection}
The \texttt{StepCollection} maps from a step within the \textit{instruction} tree to an assembly rule using IDs. As visible in \cref{fig:stepcollection}, these steps are configured by defining an ID, the type that can be one of \texttt{AssembleCompletely} and \texttt{Install}, \texttt{Remove}. Additionally, a \texttt{IGrabbableSnappable} object has to be passed for the latter two.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/misc/stepcollection.png}
    \caption{The \texttt{StepCollection}}
    \label{fig:stepcollection}
\end{figure}

The \texttt{StepController} integrates tightly with the \texttt{Assembly} component (see \cref{ssec:assemblycomp}) and the \texttt{TreeController} (see \cref{sec:treecontroller}). The \texttt{TreeController} reads all currently needed assembly steps from the tree representation and communicates them to the \texttt{StepController}. The \texttt{StepController} then looks up the defined step within the \texttt{StepCollection}, looks up its type, checks its progress against the \texttt{Assembly} (using the algorithms mentioned above), and highlights the following steps to be fulfilled. 

\section{Scenario Editor}
During the diagnosis task, the user tries to find various errors, e.g., whether there is a short circuit within the M2 Motor of the coupling or leakage within the gasket of the cylinder connector. With the help of the scenario editor (see \cref{fig:scenarioEditor}), an instructor can create new \texttt{Scenario}s by selecting which errors are present in the model and adding this new scenario to the scenario collection.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.4\textwidth]{img/30_implementation/misc/ScenarioEditor.png}
    \caption{Selecting the Type of short circuit error}
    \label{fig:scenarioEditor}
\end{figure}

\subsection{The \texttt{ScenarioController}} \label{ssec:scenariocontroller}
The \texttt{ScenarioController} lets the user select which of the previously created scenario is currently "played." It returns the current \texttt{Scenario}. As visible in \cref{fig:programmOverview}, for example, the multimeter consults the \texttt{ScenarioController}. For that, the current \texttt{Scenario} provides a function returning, e.g., the Amperage measured while moving the electronics drawer. Also, several components, e.g., the damage controller (see \cref{par:DamageController}), consult the scenario controller to determine whether to show the broken part or the intact one. As some of these displays depend on the model's current state - e.g., the various measurements of the battery voltage - the scenario itself can consult the tree controller. This component is the only one aware of the model state.


\section{Interaction Controller}\label{sec:interactioncontroller}
Apart from installing and removing objects, the steps in this simulation consist of measuring voltages, pressing buttons, replacing broken parts, etc. These steps are way less generalizable than the assembly steps, which is why they are treated differently. An ID is placed into the tree representation and mapped onto a piece of code that describes which interaction it expects in that interaction state (\ref{ssec:interactionstate}) using a similar logic as in the (assembly-) step controller (\ref{ssec:stepcollection}). The \texttt{InteractionController}'s task is to periodically check against the interaction state whether all requirements are met given the current interaction ID. 

\subsection{Interaction State}\label{ssec:interactionstate}
The interaction state references most measuring tools (e.g., Multimeter, Diagnosis Device) and all the buttons simulating part of the train. For other functionalities, it provides callback functions that UnityEvents can use. It provides a public function, which the interaction controller checks for every interaction ID. In these functions, the interaction step implements the respective logic. This logic then, e.g., checks that a particular switch has been turned on or off, a button has been pressed, a measurement has been conducted, the check for leakage has been performed, and so on. 

\section{Information Controller}\label{sec:inforContr}
The Information Controller compares to the notification area of a smartphone. If the app has to communicate something to the user, it can be done via the Information Controller. It provides a public function \texttt{PushInfo} which allows sending a \texttt{InformationPiece}. This data class consists of a level (Error, Warning, Info), a text, and a time to live. When received a new notification, a panel is created (and the others pushed upwards), and after the time to live has been exceeded, said panel is removed again. This display can be seen in \cref{fig:informationPanel}.   

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/misc/InformationPanel.png}
    \caption{The information panel, controlled by the Information controller}
    \label{fig:informationPanel}
\end{figure}

\section{Report Generator}
Similar to the Information Controller from \cref{sec:inforContr}, the developer can use the Report Generator to log anything that might be of interest for a later evaluation. For example, the Information Controller's texts are logged automatically. However, the report generator is not limited to information communicated to the user; every component can add logs. The Report Generator automatically adds a timestamp and creates a new entry in a data structure which is then saved as a \texttt{JSON} file.

% \iltodo{Do the stuff from unity again}

\section{Tools}
This section presents some of the more noteworthy tools  used in the simulation. 

\subsection{Multimeter}\label{ssec:multimeter}
The Multimeter contains two switches, a display, and two measuring tips (which implement \texttt{ISnappableGrabbable}). When both tips are plugged in, it consults the \texttt{ScenarioController} on what measurement value to display, given the current state of the switches. For said switches, it leverages the Switch-Helper (\cref{ssec:buttonhelper}). Since hand-tracking does not yield the same precision in the VR world as in the real world, simplifying the device was inevitable. As such, e.g., the prominent selection wheel or some unused buttons had to be removed. The difference is shown in \cref{fig:Multimeter}. The VR-Multimeter has been modeled using Fusion 360 \cite{fusion360}.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/Multimeter_Real.png}
         \caption{Source: \cite{shared-sprites}}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=.85\textwidth]{img/30_implementation/misc/Multimeter_VR.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Multimeter used in the simulation and the real world}
     \label{fig:Multimeter}
\end{figure}


\subsection{Diagnosis Device} 
Similar to the Multimeter (see \cref{ssec:multimeter}), the Diagnosis Device consists of two switches, two buttons, one probe-tip, and several LEDs. Most of the logic is the same as in the Multimeter. However, other than displaying the measurement via text using the display, it replaces the material of the LED objects with a green or dark-gray one to represent the light's on or off state. Also, this model has been created using Fusion 360 based on some pictures. Again the actual device and the model can be seen in \cref{fig:DiagDev}.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=.95\textwidth, trim={0 35cm 10cm 40cm},clip]{img/30_implementation/misc/DiagDevReal.jpg}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/DiagDevVR.png}
         % \caption{The installed plug}
     \end{subfigure}
     \caption{Diagnosis Device used in the simulation and the real world}
     \label{fig:DiagDev}
\end{figure}


\subsection{Loctite}
The Loctite tube is a simple \texttt{Multisnappable} object which attaches a small red sphere to the endpoint, which is part of the screw. this can be seen in \cref{fig:loctite}.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/misc/LoctiteVR.png}
    \caption{Application of Loctite}
    \label{fig:loctite}
\end{figure}

\subsection{Leakage Spray}
The Leakage Spray uses a Unity ParticleSystem \cite{UnityParticleSystem} to display the effect of spraying with the can. It is a grabbable Object which activates the particle system once grabbed. Suppose the nozzle is close enough to the spot to be tested for leakage. In that case, if the angular difference between the test spot and the nozzle lies within tolerance and the \texttt{ScenarioController} dictates a leak, another ParticleSystem (yellow) gets triggered that displays the leak (see \cref{fig:leakagespray}).

\begin{figure}[htb]
    \centering
    \includegraphics[width=.5\textwidth]{img/30_implementation/misc/LeakageSprayVR.png}
    \caption{The Leakage spray used to test whether a seal works correctly}
    \label{fig:leakagespray}
\end{figure}

\subsection{Cables}
Several cables are used within the scene, e.g., the one from the Multimeter and the simulation of the cable within the electronic box.
These cables are simulated with a minor component mostly built upon the Unity LineRenderer \cite{UnityLineRenderer}. The start- and endpoint of the lines are two Unity Transforms. As they are passed by reference to the LineRenderer, the line automatically updates when the respective \texttt{GameObject} is moved. An example of the cable is depicted in \cref{fig:cablerendere}.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/CableLinerenderer.png}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth, trim={0 1cm 0cm 1cm},clip]{img/30_implementation/misc/Cable2.png}
         % \caption{The installed plug}
     \end{subfigure}
    \caption{The cable rendered as a simple line.}
    \label{fig:cablerendere}
\end{figure}

\section{Miscellaneous Components}
This section outlines some helpful components used by several of the previously mentioned components.

\subsection{Button- and Switch-Helper}\label{ssec:buttonhelper}
The Button- and Switch helper tightly integrate with the respective Button- and Switch prefabs but are also used in various places like the Diagnosis Device. 

The Button helper consists of two parts: The interactable components for the respective input systems, a script responsible for the press animation, and the invocation of a UnityEvent if such a button has been pressed. The interaction of touchable objects is handled quite differently by the two input systems. As stated in the SG documentation \cite{SenseGloveDocs}, such a press of a button is handled via Unity colliders in the pressing finger and the object itself. The animation is started once the collider's \texttt{OnTriggerEnter} function is called, after which the Button-Pressed Event is invoked. The Meta Quest hand-tracking was rather involved and primarily based on the train example scene \cite{OculusHandsInteractionTrainScene} delivered as part of the Oculus SDK. It revolves around the poke interactable component and several colliders and planes. In theory, this component would provide a more smooth animation. That was, however, skipped in favor of a more straightforward integration with the button helper.

The Switch helper is essentially two button helpers combined with some logic to disable and hide one button when being pressed while activating the other at the same time. As the prefab - which mainly uses these components - also has a text label, both helpers expose the possibility to edit the content of said text directly. \Cref{fig:switchStuff} shows the most common application of the switch. 

\begin{figure}[htb]
    \centering
    \includegraphics[width=.4\textwidth]{img/30_implementation/misc/switchexample.png}
    \caption{Switch to turn the control current on or off.}
    \label{fig:switchStuff}
\end{figure}

\subsection{Animations}
Albeit not used too extensively in this simulation, Unity Animations \cite{UnityAnimationSection} were a handy tool to realistically depict, e.g., the extension of the electronics drawer. The drawer is animated via a Key-frame based approach by defining the start- and end-position. Unity then smoothly interpolates between the states using b-splines. This animation is then paused and resumed based on the model's state. \Cref{fig:animationref} shows the keyframes, i.e., the start and end-position of the drawer's animation.

\begin{figure}[htb]
     \centering
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/startpositionAnimation.png}
     \end{subfigure}
     \hfill
     \begin{subfigure}[htb]{.49\textwidth}
         \centering
         \includegraphics[width=\textwidth]{img/30_implementation/misc/endpositionAnimation.png}
         % \caption{The installed plug}
     \end{subfigure}
    \caption{Keyframes of the drawer extension animation}
    \label{fig:animationref}
\end{figure}

\subsection{Damage Controller}\label{par:DamageController}
Most errors involving a damaged part display are similar from a programming side: there are two models, one that displays the damaged and one that displays the intact part, only one of which is displayed. Based on the scenario, the damage controller activates the respective model while disabling the other. Displaying the leakage works similarly. It additionally contains some logic only to activate the leakage particle system if the leakage spraying can is close enough and within a reasonable angle. 

\subsection{Validating all Inputs}
To prevent errors while setting up the simulation, almost all of the self-written components override the \texttt{OnValidate} function. That allows first sanity checks when editing the component in the UnityEditor and gives direct feedback to the Programmer. The output of such a validation looks similar to \cref{fig:validateAssemblyRules}.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/misc/validateAssemblyRules.png}
    \caption{Output from the validation}
    \label{fig:validateAssemblyRules}
\end{figure}

% \clearpage
\section{State of the Animation}\label{sec:stateofanim}
Creating a complete simulation of the interactions needed is a laborious task. Due to time constraints, not every step has been fully animated. All needed tools are animated, but some interaction steps still need to be included. In the following pictures \colBox{DoneBlue} denotes the completely implemented parts \colBox{OpenOrange} the not or partially implemented parts, and \colBox{MissingAnimRed} the missing animations. 

Generally, Part 1 and Part 3 have been fully implemented in the course of this thesis. Part 2 needs to include some implementation. Part 1 and Part 3 were treated preferentially as they have similar steps making the comparison described in \cref{ssec::methodstasks} easier.

\Cref{fig:openscenarios} shows the implementation progress of the scenarios. A scenario denotes the model's state described in \cref{ssec:scenariocontroller}, i.e., what to display as measurement. All but one scenario was implemented. The last scenario can only fully be implemented once the animations in \cref{fig:openinteractionsteps} have been implemented. 


\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/state/openscenarios.png}
    \caption{Implementation progress of the scenarios, \treesource{}}
    \label{fig:openscenarios}
\end{figure}

\Cref{fig:openassemblysteps} Shows the open assembly steps (see \cref{sec:assembly_rules}). These consist of opening up the top of the coupling head and interacting with the links within the coupling head.


\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/state/openassemblysteps.png}
    \caption{Implementation progress of the assembly steps, \treesource{}}
    \label{fig:openassemblysteps}
\end{figure}

\Cref{fig:openinteractionsteps} Shows the implementation progress of the interactions and animations (see \cref{ssec:interactionstate}). The missing animations are the manual override and the mechanical interlock (see \cref{sec:themechsystem}). The unimplemented parts consist of various interactions with the override and interlock.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/state/openinteractionsteps.png}
    \caption{Implementation progress of the interactions and animations, \treesource{}}
    \label{fig:openinteractionsteps}
\end{figure}

% \clearpage
\section{Performance of the App}\label{sec:performance}
The app, including hand-tracking and SenseCom \cite{SenseCom}, works in standalone mode on the headset. As such, it only needs the headset and - depending on the case - the SenseGloves. However, the model of the coupling is rather detailed and complex and contains a multitude of vertices. As such, the app's frame rate drops considerably (often below 20 frames per second) as soon as the coupling model enters the field of view. The frames can also be computed on the computer and pushed to the headset using the Oculus Link cable \cite{QuestLinkCable}, leveraging the power of a PC's Graphics Card and Processor. That way, a constant frame rate above 60 frames per second can be achieved. \Cref{fig:frameratedrop} shows the drop in the frame rate occurring when looking at the coupling model. The upper plateau resides around 72 FPS, while the lower plateau resides between 22 and 17 FPS - low enough to be clearly perceivable with the headset.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.7\textwidth]{img/30_implementation/state/framerate.png}
    \caption{Drop in the frame rate when looking at the model below 20 FPS}
    \label{fig:frameratedrop}
\end{figure}
